A binary search algorithm finds an item in a sorted list in time.
A brute force search would walk through the whole list, taking time in the worst case.
Let's say we have a sorted list of numbers. To find a number with a binary search, we:
- Start with the middle number: is it bigger or smaller than our target number? Since the list is sorted, this tells us if the target would be in the left half or the right half of our list.
- We've effectively divided the problem in half. We can "rule out" the whole half of the list that we know doesn't contain the target number.
- Repeat the same approach (of starting in the middle) on the new half-size problem. Then do it again and again, until we either find the number or "rule out" the whole set.
We can do this recursively, or iteratively. Here's an iterative version:
How did we know the time cost of binary search was ? The only non-constant part of our time cost is the number of times our while loop runs. Each step of our while loop cuts the range (dictated by floor_index and ceiling_index) in half, until our range has just one element left.
So the question is, "how many times must we divide our original list size (n) in half until we get down to 1?"
n * \frac{1}{2} * \frac{1}{2} * \frac{1}{2} * \frac{1}{2} * ... = 1How many \frac{1}{2}'s are there? We don't know yet, but we can call that number x:
n * (\frac{1}{2})^x = 1Now we solve for x:
n * \frac{1^x}{2^x} = 1 n * \frac{1}{2^x} = 1 \frac{n}{2^x} = 1 n = 2^xNow to get the x out of the exponent. How do we do that? Logarithms.
Recall that \log_{10}{100} means, "what power must we raise 10 to, to get 100"? The answer is 2.
So in this case, if we take the \log_{2} of both sides...
\log_{2}{n} = \log_{2}{2^x}The right hand side asks, "what power must we raise 2 to, to get 2^x?" Well, that's just x.
\log_{2}{n} = xSo there it is. The number of times we must divide n in half to get down to 1 is log_{2}n. So our total time cost is
Careful: we can only use binary search if the input list is already sorted.
Pass Your Interviews with My FREE 7-Day Crash Course
I'll teach you the right way of thinking for breaking down tricky algorithmic coding interview questions you've never seen before.
No prior computer science training necessary—I'll get you up to speed quickly, skipping all the overly academic stuff.
No spam. One-click unsubscribe if you hate it.
You're in! Head over to your email inbox right now to read day one!